/* $Id: $ */

/* Copyright (C) 1990 Bjrn Kirkerud and Steinar Kjernsrd
 * Department of Informatics, University of Oslo.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<stdio.h>
/**
  Transfer command line arguments to SIMULA main program.
  Compile: cc -c arg.c
 **/

int                   arg (argv, simbuf, argind, tlen, argc)
char                 *simbuf;	/* Adress of SIMULA TEXT object		 */
char                **argv;	/* Adress of commandline string vector 	 */
int                   argind;	/* Number of arguments to process	 */
int                   tlen;	/* Length of the SIMULA TEXT object      */
int                   argc;	/* Total number of arguments 		 */
{

   char                 *pos;
   int                   i,
                         j = 0;

   if (argind >= 0 && strlen (argv[argind]) <= tlen)
   {

   /*
    * Return only argv[argind]
    */
      strcpy (simbuf, argv[argind]);
      simbuf[strlen (simbuf)] = ' ';
      return (1);
   }

/*
 * Return all arguments
 */

   for (i = 0; i < argc; i++)
   {

      pos = *(argv++);		/* Point pos to start of current argument */

      while (*pos != 0)
      {
	 if (j == tlen)
	    return (-1);	/* To be safe */

	 simbuf[j++] = *(pos++);

      }

      simbuf[j++] = ' ';	/* Insert space between arguments */

   }

   return (1);

}
